package eu.jonahbauer.tichu.common.model.combinations;

import eu.jonahbauer.tichu.common.model.Card;
import eu.jonahbauer.tichu.common.model.CombinationType;
import org.jetbrains.annotations.Contract;
import org.jetbrains.annotations.NotNull;

import java.util.List;
import java.util.Objects;

/**
 * A combination of type {@link CombinationType#PAIR}
 */
public final class Pair extends Tuple {
    @Contract("_ -> new")
    public static @NotNull Pair of(@NotNull List<@NotNull Card> cards) {
        return new Pair(cards);
    }

    @Contract("_, _ -> new")
    public static @NotNull Pair of(@NotNull Card card1, @NotNull Card card2) {
        return new Pair(List.of(
                Objects.requireNonNull(card1, "card1 must not be null"),
                Objects.requireNonNull(card2, "card2 must not be null")
        ));
    }

    Pair(@NotNull List<@NotNull Card> cards) {
        super(CombinationType.PAIR, cards);
    }
}
