package eu.jonahbauer.tichu.common.model.exceptions;

import eu.jonahbauer.tichu.common.model.Stack;
import eu.jonahbauer.tichu.common.model.combinations.Combination;
import lombok.Getter;
import org.jetbrains.annotations.NotNull;

import java.util.Objects;

@Getter
public class TooLowCombinationException extends IllegalArgumentException {
    private final @NotNull Stack stack;
    private final @NotNull Combination combination;

    public TooLowCombinationException(@NotNull Stack stack, @NotNull Combination combination) {
        this.stack = Objects.requireNonNull(stack, "stack must not be null");
        this.combination = Objects.requireNonNull(combination, "combination must not be null");
    }

    @Override
    public String getMessage() {
        return "Cannot play %s on top of %s.".formatted(combination, stack);
    }
}
